<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */

# Escribe en formato de asigna
# Dominio pblico. 2005. vtamara@pasosdejesus.org
 
require_once 'misc.php';
require_once 'conf.php';

encabezado("Asignacin de horario");

$profesores=$horas=$salones=0;
$prof=$hora=$salon=$carga=$fija=array();
valida($profesores, $horas, $salones, $prof, $hora, $salon, $carga, $fija);


echo "Un momento por favor, intentando cuadrar horario<br>\n";

$nt = tempnam ("/tmp", "FOO");

$fp = fopen($nt, "w");
if (!$fp) {
    die("No pudo abrirse archivo $nt para escribir<br>Por favor, verifique que exista el directorio /tmp (a la vista del servidor web) y que el  usuario con el que corre el servidor web tenga permiso de escritura.");
}

fputs ($fp, "$profesores\n");
fputs($fp, "s\n");
for($i=0;$i<$profesores;$i++) {
	fputs($fp, $prof[$i]."\n");
}
fputs($fp, "$horas\n");
fputs($fp, "s\n");
for($i=0;$i<$horas;$i++) {
	fputs($fp, $hora[$i]."\n");
}
fputs($fp, "$salones\n");
fputs($fp, "s\n");
for($i=0;$i<$salones;$i++) {
	fputs($fp, $salon[$i]."\n");
}
for($p=0;$p<$profesores;$p++) {
	$hf=array();
	for($s=0;$s<$salones;$s++) {
		fputs($fp, $carga[$p][$s]."\n");
		for ($h=0; $h<$horas; $h++) {
			if ($fija[$s][$h]==$p) {
				$hf[]=array(0=>$s, 1=>$h);
			}
		}
	}
    fputs($fp, count($hf)."\n");
	foreach($hf as $v) {
		fputs($fp, $hora[$v[0]]."\n");
		fputs($fp, $salon[$v[1]]."\n");
	}
}
fclose ($fp);
$cmd=asigna . " -a $nt";
echo "<pre>Ejecutando $cmd<br></pre>";
$res=`$cmd`;
echo "Horario resultante:";

$n=split("\n", $res);
$cn=0;
for ($h=0; $h<$horas; $h++) {
    for($s=0;$s<$salones;$s++) {
        $horf[$s][$h]=(int)$n[$cn];
        $cn++;
    }
}


echo "<center><table border=\"1\">\n<tr><th>S\H</th>";
for($h=0; $h<$horas; $h++) {
	echo "<th>".$hora[$h]."</th>";
}

echo "<th></tr>\n";
for($s=0; $s<$salones; $s++) {
	echo "<tr><th>".$salon[$s]."</th>";
	for($h=0; $h<$horas; $h++) {
		echo "<td>".$prof[$horf[$s][$h]]."</td>";
	}
}
echo "</table></center>\n";

echo "<form action=\"simplex.php\" method=\"POST\">\n";

escondidos($profesores, $horas, $salones, $prof, $hora, $salon, $carga, $fija);

echo "<p><input type=\"submit\" value=\"Opcional: Simplex\"/>\n</p>";
echo "</form>";

pie();
?>
