<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */

# Plantea com prob. prog. lineal y presenta en formato de lp_solve
# Dominio pblico. 2005. vtamara@pasosdejesus.org
 
require_once 'misc.php';
require_once 'conf.php';

encabezado("Planteamiento como problema de programacin lineal");

$profesores=$horas=$salones=0;
$prof=$hora=$salon=$carga=$fija=array();
valida($profesores, $horas, $salones, $prof, $hora, $salon, $carga, $fija);


$nt = tempnam ("/tmp", "FOO");

$fp = fopen($nt, "w");
if (!$fp) {
    die("No pudo abrirse archivo $nt para escribir<br>Por favor, verifique que exista el directorio /tmp (a la vista del servidor web) y que el  usuario con el que corre el servidor web tenga permiso de escritura.");
}

fputs ($fp, "$profesores\n");
fputs($fp, "s\n");
for($i=0;$i<$profesores;$i++) {
	fputs($fp, $prof[$i]."\n");
}
fputs($fp, "$horas\n");
fputs($fp, "s\n");
for($i=0;$i<$horas;$i++) {
	fputs($fp, $hora[$i]."\n");
}
fputs($fp, "$salones\n");
fputs($fp, "s\n");
for($i=0;$i<$salones;$i++) {
	fputs($fp, $salon[$i]."\n");
}
for($p=0;$p<$profesores;$p++) {
	$hf=array();
	for($s=0;$s<$salones;$s++) {
		fputs($fp, $carga[$p][$s]."\n");
		for ($h=0; $h<$horas; $h++) {
			if ($fija[$s][$h]==$p) {
				$hf[]=array(0=>$s, 1=>$h);
			}
		}
	}
    fputs($fp, count($hf)."\n");
	foreach($hf as $v) {
		fputs($fp, $hora[$v[0]]."\n");
		fputs($fp, $salon[$v[1]]."\n");
	}
}
fclose ($fp);
$cmd=asigna . " -p -a $nt";
echo "<pre>Ejecutando $cmd<br></pre>";
$res=`$cmd`;
echo "Resultado:";
echo "<pre>".$res."</pre>";

pie();
?>
